﻿ArkInventoryRules_GFM = LibStub( "AceAddon-3.0" ):NewAddon( "ArkInventoryRules_GFM" )

function ArkInventoryRules_GFM:OnEnable( )
	
	ArkInventoryRules.Register( self, "GFM", ArkInventoryRules_GFM.Execute )
	
end

function ArkInventoryRules_GFM.Execute( ... )

	-- always check for the hyperlink and that it's an actual item, not a spell (pet/mount)
	if not ArkInventoryRules.Object.h or ArkInventoryRules.Object.class ~= "item" then
		return false
	end
	
	local fn = "GFM" -- your rule name, needs to be set so that error messages are readable
	
	local ac = select( '#', ... )
	
	-- if you need at least 1 argument, this is how you check, if you dont need any arguments then you need to remove this part or rewrite it to suit your needs
--	if ac == 0 then
--		error( string.format( ArkInventory.Localise["RULE_FAILED_ARGUMENT_NONE_SPECIFIED"], fn ), 0 )
--	end
	
	local class = ArkInventory.Global.Me.info.class
	
	local objecttype = string.lower( select( 8, ArkInventory.ObjectInfo( ArkInventoryRules.Object.h ) ) ) 
	local objectsubtype = string.lower( select( 9, ArkInventory.ObjectInfo( ArkInventoryRules.Object.h ) ) )
	local objectequip = string.lower ( select( 11, ArkInventory.ObjectInfo( ArkInventoryRules.Object.h ) ) )
	
	if objecttype == "trinket" then return true end
	
	if objecttype == "armor" then
		
		if objectsubtype == "miscellaneous" then return true end
		if objectequip == "invtype_cloak" then return true end
		if objectequip == "invtype_trinket" then return true end
		if objectequip == "invtype_neck" then return true end
		if objectequip == "invtype_finger" then return true end
	
		if ( ( class == "WARRIOR" ) and ( objectsubtype == "plate") ) then return true end
		if ( ( class == "WARRIOR" ) and ( objectsubtype == "shields") ) then return true end
		if ( ( class == "DEATHKNIGHT" ) and ( objectsubtype == "plate") ) then return true end
		if ( ( class == "PALADIN" ) and ( objectsubtype == "plate") ) then return true end
		if ( ( class == "PALADIN" ) and ( objectsubtype == "shields") ) then return true end
		if ( ( class == "PRIEST" ) and ( objectsubtype == "cloth") ) then return true end
		if ( ( class == "MAGE" ) and ( objectsubtype == "cloth") ) then return true end
		if ( ( class == "WARLOCK" ) and ( objectsubtype == "cloth") ) then return true end
		if ( ( class == "HUNTER" ) and ( objectsubtype == "mail") ) then return true end
		if ( ( class == "SHAMAN" ) and ( objectsubtype == "mail") ) then return true end
		if ( ( class == "SHAMAN" ) and ( objectsubtype == "shields") ) then return true end
		if ( ( class == "DRUID" ) and ( objectsubtype == "leather") ) then return true end
		if ( ( class == "ROGUE" ) and ( objectsubtype == "leather") ) then return true end
		if ( ( class == "MONK" ) and ( objectsubtype == "leather") ) then return true end
		if ( ( class == "DEMONHUNTER" ) and ( objectsubtype == "leather") ) then return true end
	end
	
	if objecttype == "weapon" then
		
		if ( class == "DEMONHUNTER" ) and ( 
			( objectsubtype == "warglaives") or
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "daggers") or
			( objectsubtype == "fist weapons")
		) then return true end
		
		if ( class == "WARRIOR" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "two-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "daggers") or
			( objectsubtype == "polearms") or
			( objectsubtype == "fist weapons")
		) then return true end
	
		if ( class == "DEATHKNIGHT" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "two-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "polearms")
		) then return true end
		
		if ( class == "PALADIN" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "two-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "polearms")
		) then return true end
		
		if ( class == "PRIEST" ) and ( 
			( objectsubtype == "staves") or
			( objectsubtype == "wands") or
			( objectsubtype == "daggers") or
			( objectsubtype == "one-handed maces")
		) then return true end
		
		if ( class == "MAGE" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "staves") or
			( objectsubtype == "daggers") or
			( objectsubtype == "wands")
		) then return true end
		
		if ( class == "WARLOCK" ) and (
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "staves") or
			( objectsubtype == "daggers") or
			( objectsubtype == "wands")
		) then return true end
		
		if ( class == "HUNTER" ) and ( 
			( objectsubtype == "crossbows") or
			( objectsubtype == "bows") or
			( objectsubtype == "guns")
			( objectsubtype == "polearms")
		) then return true end
		
		if ( class == "SHAMAN" ) and (
			( objectsubtype == "staves") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "daggers") or
			( objectsubtype == "fist weapons")
		) then return true end
		
		if ( class == "DRUID" ) and (
			( objectsubtype == "staves") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "polearms") or
			( objectsubtype == "daggers") or
			( objectsubtype == "fist weapons")
		) then return true end
	
		if ( class == "ROGUE" ) and (
			( objectsubtype == "daggers") or
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "fist weapons")
		) then return true end
		
		if ( class == "MONK" ) and (
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "polearms") or
			( objectsubtype == "staves") or
			( objectsubtype == "fist weapons")
		) then return true end
		
	end
	
	-- always return false at the end
	return false
	
end
